/*
 *  GriddedGroup.h
 *  Assignment6
 *
 *  Created by Zach Gildersleeve on 2/26/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef GRIDDEDGROUP_H
#define GRIDDEDBROUP_H

#include "Group.h"
#include "Timer.h"
#include "Point.h"
#include "Vector.h"
#include <vector>
#include <queue>
#include "Cell.h"
#include "BoundingBox.h"
#include "Ray.h"

class GriddedGroup : public Group {
	public:
		GriddedGroup(double newNumberOfCells);
		virtual ~GriddedGroup() {}
		
		virtual void addObject(Object *newObject);
		virtual void preprocess();
		virtual bool intersect(HitRecord &hit, const RenderContext &context, const Ray &ray) const;
	
	private:
		double numberOfCells;
		int nx, ny, nz;
		Point min;
		Point max;
		Vector diagonal;
		int objectCount;
		Vector cellSize;
		Vector inverseCellSize;
		vector<Cell> cellList;
		queue<Object*, deque<Object*> > objectQueue;
		Point pt[2];		
		void getGridCoordinates(const BoundingBox& box, int& sX, int& sY, int& sZ, int& eX, int& eY, int& eZ) const;
};

inline int Floor(double d)
{
	if (d < 0)
	{
		int i = -static_cast<int>(-d);
		if (i == d)
			return i;
		else
			return i-1;
	} else {
		return static_cast<int>(d);
	}
}

inline int Ceil(double d)
{
	if (d < 0)
	{
		int i = -static_cast<int>(-d);
		return i;
	} else {
		int i = static_cast<int>(d);
		if (i == d)
			return i;
		else
			return i+1;
	}
}

#endif