/*
 *  Group.h
 *  Assignment2
 *
 *  Created by Zach Gildersleeve on 1/29/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef GROUP_H
#define GROUP_H

#include <vector>
#include "Object.h"
#include "BoundingBox.h"

class Group : public Object {
	public:
		Group();
		Group(int size);
		virtual ~Group();
		
		void preprocess();
		
		void addObject(Object *obj);
		virtual void getBounds(BoundingBox& bbox) const;
		virtual bool intersect(HitRecord &hit, const RenderContext &context, const Ray &ray) const;
	
		Group(const Group &g);
		Group &operator=(const Group &g);
	
	private:
		std::vector<Object*> objectList;
		int listSize;
};

#endif
