/*
 *  PinholeCamera.h
 *  Assignment2
 *
 *  Created by Zach Gildersleeve on 1/27/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef PINHOLECAMERA_H
#define PINHOLECAMERA_H

#include "Camera.h"
#include "Point.h"
#include "Vector.h"
#include "Ray.h"
#include <math.h>

class PinholeCamera : public Camera {
	public:
		PinholeCamera(const Point &newPosition, const Point &newLookat, const Vector &newUp, double newfov);
		~PinholeCamera();
		
		virtual void preprocess(double aspectRatio);
		virtual void makeRay(Ray &ray, const RenderContext &context, double x, double y) const;
		
	private:
		Point position;
		Point lookat;
		Vector up;
		double fov;
		Vector u;
		Vector v;
		Vector normalDirection;
};

#endif